function [ output_args ] = DIP()
clear;
clc;
close all
file='lena.tif';
file2='lena_mask.tif';
RGBimage=imread(file);


fig1=figure(1);
subplot(1,3,1)
imshow(RGBimage);
title('Original Image')
RGBimage(5,5,1);


image2=RGBimage(255:400,255:400,1:3); 
subplot(1,3,2)
imshow(image2);
title('Selection of Image')
impixelinfo

subplot(1,3,3)
imshow(RGBimage(:,:,1));
title('Red Channel')


figure(2)
subplot(3,2,1)
grayimage=rgb2gray(RGBimage);
grayimage4=grayslice(grayimage,4);
grayimage16=grayslice(grayimage,16);
imshow(grayimage16);
title('Gray Image 16')

subplot(3,2,2)
imshow(grayimage4);
title('Gray Image 4')


subplot(3,2,3)
imhist(grayimage16);
axis([-50 300 0 max(imhist(grayimage16))]);
title('Histogram of Gray Image 16')

subplot(3,2,4)
imhist(grayimage4);
axis([-50 300 0 max(imhist(grayimage4))]);
title('Histogram of Gray Image 4')

subplot(3,2,5) %TODO
histeq(grayimage16);
title('Hist Equal 16')

subplot(3,2,6) 
histeq(grayimage4);
title('Hist Equal 4')

figure(3)
mycolormap=[1 0 1; 1 1 1;0 1 0; 1 0 0];
imshow(grayimage4,mycolormap);
title('Image with color map')

figure(4)
subplot(1,3,1)
binimage=grayimage<100;
imshow(binimage);
title('Binary Image')
impixelinfo

subplot(1,3,2)
noiseimage=imnoise(grayimage,'salt & pepper');
imshow(noiseimage);
title('Salt and Pepper')

filtered=medfilt2(noiseimage);
subplot(1,3,3)
imshow(filtered);
title('Filtered')


d_grayimage=im2double(grayimage);
new=1-d_grayimage;
figure(5)
subplot(2,2,1)
new_plus=imadd(grayimage,128);
new_minus=imsubtract(grayimage,128);
new_div=imdivide(grayimage,2);
new_mul=immultiply(grayimage,2);
imshow(new_plus);
title('Added')
subplot(2,2,2)
imshow(new_minus);
title('Subtracted')
subplot(2,2,3)
imshow(new_div);
title('Divided')
subplot(2,2,4)
imshow(new_mul);
title('Multiplied')


masked=imread(file2);
binimage2=masked<1;
new2=immultiply(grayimage,binimage2);
figure(6)
subplot(1,3,1)
imshow(masked)
title('Masked')
subplot(1,3,2)
imshow(binimage2);
title('Binary')
subplot(1,3,3);
imshow(new2);
title('Multiplied')

a=ones(3,3)/9;
b=ones(5,5)/25;
c=ones(9,9)/81;
con_a=conv2(d_grayimage,a);
con_b=conv2(d_grayimage,b);
con_c=conv2(d_grayimage,c);
figure(7)
subplot(1,3,1)
imshow(con_a)
title('3x3')
subplot(1,3,2)
imshow(con_b)
title('5x5')
subplot(1,3,3)
imshow(con_c)
title('9x9')

figure(8)
mask=fspecial('laplacian');
mask_l=conv2(grayimage,mask);
subplot(2,2,1)
imshow(mask_l);
title('Laplacian')
overlap2=imdivide(mask_l,100);
subplot(2,2,2)
imshow(overlap2)
title('Laplacian divdied by 100')

mask2=fspecial('average');
mask_ave=conv2(grayimage,mask2);
subplot(2,2,3)
imshow(mask_ave);
title('Ave')
average_image= mask_ave(2:513,2:513,:);
unsharp_image=double(grayimage)-average_image/1.5;
divid=imdivide(unsharp_image,70);
subplot(2,2,4)
imshow(divid)
title('Divided by 70')

f_image=fftshift(fft2(grayimage));
figure(9)
subplot(2,2,1)
imshow(mat2gray(log(1+abs(f_image))))
title('Fourier Spectrum')



[x,y]=meshgrid(-256:255,-256:255);
z=sqrt(x.^2+y.^2);
c=z<15;
subplot(2,2,2)
imshow(c);
title('Binary image of c')

lowpass_f_image=f_image.*c;
subplot(2,2,3)
imshow(mat2gray(log(1+abs(lowpass_f_image))))
title('Fourier Low Pass')

lowpass_if_image=ifft2(ifftshift(lowpass_f_image)); %Issue becomes imaginary
subplot(2,2,4)
imshow(uint8(lowpass_if_image)) %TODO Uncomment
title('Ringing')

%Gaussian
gaussianfilter=mat2gray(fspecial('gaussian',512,20));
lowpass_gf_image=f_image.*gaussianfilter;
lowpass_igf_image=ifft2(ifftshift(lowpass_gf_image));
figure(10)
subplot(2,2,1)
imshow(uint8(lowpass_igf_image)) %TODO Uncomment
title('Low Pass Gaussian')

c2=z>15;
high_pass=f_image.*c2;
highpass_igf_image=ifft2(ifftshift(high_pass));
subplot(2,2,2)
imshow(mat2gray(log(1+abs(high_pass)))) 
title('Ideal High Pass Fourier Spectum')

subplot(2,2,3)
imshow(uint8(highpass_igf_image)) %TODO Uncomment
title('Ideal High Pass Applied Image')

highpass_fil=1-gaussianfilter;
highpass_gf_image=f_image.*highpass_fil;
highpass_igf=ifft2(ifftshift(highpass_gf_image));
subplot(2,2,4)
imshow(uint8(highpass_igf)) %TODO Uncomment
title('High Pass Gaussian')

s=size(grayimage);
[x,y]=meshgrid(1:s(1),1:s(2));
p=sin(x/7+y/6)+1;
periodic_noiseimage=(im2double(grayimage)+p/2)/2;
figure(11)
subplot(3,2,1)
imshow(periodic_noiseimage)
title('Noise')
f_noise=fftshift(fft2(periodic_noiseimage));
subplot(3,2,2)
imshow(mat2gray(log(1+abs(f_noise))))
title('Fourier Spectrum of noise')

%Band Reject
z=sqrt((x-256).^2+(y-256).^2);
min_limit=14;
max_limit=22;
bandreject_mask=(z < min_limit | z > max_limit);
band_rejected_image= f_noise.*bandreject_mask;

subplot(3,2,3)
imshow(mat2gray(log(1+abs(band_rejected_image))))
title('Band Reject')

%TODO
subplot(3,2,4)
band_inverse=ifft2(ifftshift(band_rejected_image));
imshow(band_inverse)
title('Inverse Band Reject')

band_stop_filter=ones(512,512);
band_stop_filter(269:272,:)=0;
band_stop_filter(:,266: 269)=0;
band_stop_filter(241:244,:)=0;
band_stop_filter(:,243: 246)=0;
band_stopped_f_periodic_noiseimage= f_noise.* band_stop_filter;
subplot(3,2,5)
imshow(mat2gray(log(1+abs(band_stopped_f_periodic_noiseimage))));
title('Band Stop')

subplot(3,2,6)
final=ifft2(ifftshift(band_stopped_f_periodic_noiseimage));
imshow(final)
title('Inverse Band Stop')
end

